import ORGUSERService from '@/service/orguser/orguser-service';
import { Verify } from '@/utils/verify/verify';


/**
 * 获取人员的机构
 *
 * @export
 * @class GetOrgNameByUserBase
 */
export default class GetOrgNameByUserBase {

    /**
     * 名称
     * 
     * @memberof  GetOrgNameByUserBase
     */
    private name:string ="GetOrgNameByUser";

    /**
     * 唯一标识
     * 
     * @memberof  GetOrgNameByUserBase
     */
    private id:string = "22c21f3ac51fe73aeb1a96e9367ccc95";

    /**
     * 默认参数名称
     * 
     * @memberof  GetOrgNameByUserBase
     */
    private defaultParamName:string = "Default";

    /**
     * Creates an instance of  GetOrgNameByUserBase.
     * 
     * @param {*} [opts={}]
     * @memberof  GetOrgNameByUserBase
     */
    constructor(opts: any = {}) {
        
    }


    /**
     * 计算0节点结果
     * 
     * @param params 传入参数
     */
    public compute0Cond(params:any):boolean{
        return true;
    }

    /**
     * 计算1节点结果
     * 
     * @param params 传入参数
     */
    public compute1Cond(params:any):boolean{
        return true;
    }

    /**
     * 计算2节点结果
     * 
     * @param params 传入参数
     */
    public compute2Cond(params:any):boolean{
        return true;
    }

    /**
     * 执行逻辑
     * 
     * @param context 应用上下文
     * @param params 传入参数
     */
    public onExecute(context:any,params:any,isloading:boolean){
        return this.executeBegin(context,params,isloading);
    }


    /**
    * 开始
    * 
    * @param params 传入参数
    */
    private async executeBegin(context:any,params:any,isloading:boolean){
        //开始节点
        if(this.compute0Cond(params)){
            return this.executePrepareparam1(context,params,isloading);   
        }
    }

    /**
    * 填充查询回的人员信息
    * 
    * @param context 应用上下文
    * @param params 传入参数
    */
    private async executePrepareparam2(context:any,params:any,isloading:boolean){
        // 准备参数节点
        Object.assign(params,{orgid:params.orgid});
        Object.assign(context,{cid:params.orgid});
        Object.assign(params,{orgname:params.orgname});
        return params;
    }

    /**
    * 获取保险单操作员
    * 
    * @param context 应用上下文
    * @param params 传入参数
    */
    private async executePrepareparam1(context:any,params:any,isloading:boolean){
        // 准备参数节点
        Object.assign(params,{orguserid:params.orguserid});
        Object.assign(context,{orguser:params.orguserid});
        if(this.compute1Cond(params)){
            return this.executeDeaction1(context,params,isloading);   
        }
    }

    /**
    * 查询操作人信息
    * 
    * @param context 应用上下文
    * @param params 传入参数
    */
    private async executeDeaction1(context:any,params:any,isloading:boolean){
        // 行为处理节点
        let result: any;
        const targetService:ORGUSERService = new ORGUSERService();
        if (targetService['Get'] && targetService['Get'] instanceof Function) {
            result = await targetService['Get'](context,params, false);
        }
        if(result && result.status == 200){
            Object.assign(params,result.data);
        if(this.compute2Cond(params)){
            return this.executePrepareparam2(context,params,isloading);   
        }
        }
    }


}